C
C This program calculates the Coordinate transformation matrix between two given
C reference frames. In input is taken as Matrix A (SAMPLE AXIS) and Matrix B (CRYSTAL AXIS). 
C And the transformation  matrix is obtained as MatB-J-MatA (GRAIN J SAMPLE). This way 
Corientations relationship matrix in a poly crystalmaterial can obtained which has a bias
C, for example Cu or Cube texture. 
C

c Developed by Saurabh Kundu, Cambridge 2006.

      PROGRAM CRYSTAL_BIAS_TEXTURE
      
      IMPLICIT NONE
      INTEGER RW,RWW
      DOUBLE PRECISION PI
      
      PARAMETER(RW=99,RWW=98,PI=3.141592654)
      
      INTEGER I,J,L,ISEED,GG,GRAINS
      DOUBLE PRECISION DET,MAT_A(3,3),MAT_B(3,3),IN_MATA(3,3)
      DOUBLE PRECISION A_X(3),A_Y(3),A_Z(3),B_X(3),B_Y(3),B_Z(3)
      DOUBLE PRECISION CONV_MAT(3,3),K,G,M,IN_CONV_MAT(3,3)
      DOUBLE PRECISION ROTATION_MAT(3,3),S,N,U,V,W,TEMP(4),A
      DOUBLE PRECISION MAG
      INTEGER POLE,HEMI
      
      ISEED=TIME()
      CALL SRAND(ISEED)
      
      OPEN(RW,FILE='xy-bias-texture.txt',STATUS='OLD')
      OPEN(RWW,FILE='matrix-bias-texture-raw.txt',STATUS='OLD')
      
      WRITE(*,*) 'INPUT direction of crystal A (sample axis):'
      READ(*,*) A_X(1),A_X(2),A_X(3)
      WRITE(*,*) 'INPUT direction of crystal B (crystal axis) which is 
&      parallel to A:'
      READ(*,*) B_X(1),B_X(2),B_X(3)
      
      WRITE(*,*) 'INPUT direction of crystal A (sample axis):'
      READ(*,*) A_Y(1),A_Y(2),A_Y(3)
      WRITE(*,*) 'INPUT direction of crystal B (crystal axis) which is 
&      parallel to A:'
      READ(*,*) B_Y(1),B_Y(2),B_Y(3)
      
      WRITE(*,*) 'INPUT number of grains'
      READ(*,*) GRAINS
      
      WRITE(*,*) 'Which pole you want to print: 100, 110 or 111'
      READ(*,*) POLE
      WRITE(*,*) 'WHICH HEMISPHERE: UPPER = 1 LOWER = 0 BOTH = 2'
      READ(*,*) HEMI
      CALL CROSS_PROD(A_X,A_Y,A_Z)
      CALL CROSS_PROD(B_X,B_Y,B_Z)
      
C      WRITE(*,*) 'INPUT direction of crystal A:'
C      READ(*,*) A_Z(1),A_Z(2),A_Z(3)
C      WRITE(*,*) 'INPUT direction of crystal B which is parallel to A:'
C      READ(*,*) B_Z(1),B_Z(2),B_Z(3)
      ROTATION_MAT(1,1)=1
      ROTATION_MAT(1,2)=0
      ROTATION_MAT(1,3)=0
      
      ROTATION_MAT(2,1)=0
      ROTATION_MAT(2,2)=1
      ROTATION_MAT(2,3)=0
      
      ROTATION_MAT(3,1)=0
      ROTATION_MAT(3,2)=0
      ROTATION_MAT(3,3)=1
      
      K=SQRT(A_X(1)**2+A_X(2)**2+A_X(3)**2)/
&       SQRT(B_X(1)**2+B_X(2)**2+B_X(3)**2)

      G=SQRT(A_Y(1)**2+A_Y(2)**2+A_Y(3)**2)/
&       SQRT(B_Y(1)**2+B_Y(2)**2+B_Y(3)**2)

      M=SQRT(A_Z(1)**2+A_Z(2)**2+A_Z(3)**2)/
&       SQRT(B_Z(1)**2+B_Z(2)**2+B_Z(3)**2)


      MAT_A(1,1)=A_X(1)
      MAT_A(1,2)=A_Y(1)
      MAT_A(1,3)=A_Z(1)
      
      MAT_A(2,1)=A_X(2)
      MAT_A(2,2)=A_Y(2)
      MAT_A(2,3)=A_Z(2)
      
      MAT_A(3,1)=A_X(3)
      MAT_A(3,2)=A_Y(3)
      MAT_A(3,3)=A_Z(3)
      
      MAT_B(1,1)=B_X(1)*K
      MAT_B(1,2)=B_Y(1)*G
      MAT_B(1,3)=B_Z(1)*M
      
      MAT_B(2,1)=B_X(2)*K
      MAT_B(2,2)=B_Y(2)*G
      MAT_B(2,3)=B_Z(2)*M
      
      MAT_B(3,1)=B_X(3)*K
      MAT_B(3,2)=B_Y(3)*G
      MAT_B(3,3)=B_Z(3)*M
      
      DET=MAT_A(1,1)*(MAT_A(2,2)*MAT_A(3,3)-MAT_A(2,3)*MAT_A(3,2))
&         -MAT_A(1,2)*(MAT_A(2,1)*MAT_A(3,3)-MAT_A(2,3)*MAT_A(3,1))
&         +MAT_A(1,3)*(MAT_A(2,1)*MAT_A(3,2)-MAT_A(2,2)*MAT_A(3,1))

      IN_MATA(1,1)=(MAT_A(2,2)*MAT_A(3,3)-MAT_A(2,3)*MAT_A(3,2))/DET
      IN_MATA(1,2)=(MAT_A(3,2)*MAT_A(1,3)-MAT_A(3,3)*MAT_A(1,2))/DET
      IN_MATA(1,3)=(MAT_A(1,2)*MAT_A(2,3)-MAT_A(1,3)*MAT_A(2,2))/DET
      
      IN_MATA(2,1)=(MAT_A(2,3)*MAT_A(3,1)-MAT_A(2,1)*MAT_A(3,3))/DET
      IN_MATA(2,2)=(MAT_A(3,3)*MAT_A(1,1)-MAT_A(3,1)*MAT_A(1,3))/DET
      IN_MATA(2,3)=(MAT_A(1,3)*MAT_A(2,1)-MAT_A(1,1)*MAT_A(2,3))/DET
      
      IN_MATA(3,1)=(MAT_A(2,1)*MAT_A(3,2)-MAT_A(2,2)*MAT_A(3,1))/DET
      IN_MATA(3,2)=(MAT_A(3,1)*MAT_A(1,2)-MAT_A(3,2)*MAT_A(1,1))/DET
      IN_MATA(3,3)=(MAT_A(1,1)*MAT_A(2,2)-MAT_A(1,2)*MAT_A(2,1))/DET
      
      DO 10 I=1,3
         DO 20 J=1,3
            CONV_MAT(I,J)=0
   20    CONTINUE
   10 CONTINUE
   
      DO 30 I=1,3
         DO 40 J=1,3
            DO 50 L=1,3
               CONV_MAT(I,J)=CONV_MAT(I,J) + MAT_B(I,L)*IN_MATA(L,J)
   50       CONTINUE
   40    CONTINUE
   30 CONTINUE 
   
C      WRITE(*,*) 'MATB_J_MATA:'
      DO 60 I=1,3
C         WRITE(*,*) CONV_MAT(I,1), CONV_MAT(I,2), CONV_MAT(I,3)
   60 CONTINUE
   
      DET=CONV_MAT(1,1)*(CONV_MAT(2,2)*CONV_MAT(3,3)-CONV_MAT(2,3)
&       *CONV_MAT(3,2))
&         -CONV_MAT(1,2)*(CONV_MAT(2,1)*CONV_MAT(3,3)-CONV_MAT(2,3)
&       *CONV_MAT(3,1))
&         +CONV_MAT(1,3)*(CONV_MAT(2,1)*CONV_MAT(3,2)-CONV_MAT(2,2)
&       *CONV_MAT(3,1))

      IN_CONV_MAT(1,1)=(CONV_MAT(2,2)*CONV_MAT(3,3)-CONV_MAT(2,3)
&      *CONV_MAT(3,2))/DET
      IN_CONV_MAT(1,2)=(CONV_MAT(3,2)*CONV_MAT(1,3)-CONV_MAT(3,3)
&      *CONV_MAT(1,2))/DET
      IN_CONV_MAT(1,3)=(CONV_MAT(1,2)*CONV_MAT(2,3)-CONV_MAT(1,3)
&      *CONV_MAT(2,2))/DET
      
      IN_CONV_MAT(2,1)=(CONV_MAT(2,3)*CONV_MAT(3,1)-CONV_MAT(2,1)
&      *CONV_MAT(3,3))/DET
      IN_CONV_MAT(2,2)=(CONV_MAT(3,3)*CONV_MAT(1,1)-CONV_MAT(3,1)
&      *CONV_MAT(1,3))/DET
      IN_CONV_MAT(2,3)=(CONV_MAT(1,3)*CONV_MAT(2,1)-CONV_MAT(1,1)
&      *CONV_MAT(2,3))/DET
      
      IN_CONV_MAT(3,1)=(CONV_MAT(2,1)*CONV_MAT(3,2)-CONV_MAT(2,2)
&      *CONV_MAT(3,1))/DET
      IN_CONV_MAT(3,2)=(CONV_MAT(3,1)*CONV_MAT(1,2)-CONV_MAT(3,2)
&      *CONV_MAT(1,1))/DET
      IN_CONV_MAT(3,3)=(CONV_MAT(1,1)*CONV_MAT(2,2)-CONV_MAT(1,2)
&      *CONV_MAT(2,1))/DET

C      WRITE(*,*) 'MATA_J_MATB:'
      DO 70 I=1,3
C         WRITE(*,*) IN_CONV_MAT(I,1), IN_CONV_MAT(I,2), IN_CONV_MAT(I,3)
   70 CONTINUE
      
      DO 80 I=1,GRAINS
         CALL GET_BIAS_TEXTURE(CONV_MAT,ROTATION_MAT,POLE,HEMI)
         GG=1
      DO 90 GG=1,3
            A=RAND()
            TEMP(GG)=2*A-1.0d+00
   90 CONTINUE


C VERY IMPORTANT : CHANGING THIS ANGLE CHANGES THE INTENSITY OF THE TEXTURE
      TEMP(4)=RAND()*(2*PI)/8


C VERY IMPORTANT : CHANGING THIS ANGLE CHANGES THE INTENSITY OF THE TEXTURE
   
      S=DCOS(TEMP(4))
      N=DSIN(TEMP(4))
      MAG=DSQRT(TEMP(1)**2+TEMP(2)**2+TEMP(3)**2)
      U=TEMP(1)/MAG
      V=TEMP(2)/MAG
      W=TEMP(3)/MAG
      
      ROTATION_MAT(1,1)=U*U*(1.0D+00-S)+S
      ROTATION_MAT(1,2)=U*V*(1.0D+00-S)+W*N
      ROTATION_MAT(1,3)=U*W*(1.0D+00-S)-V*N
      
      ROTATION_MAT(2,1)=U*V*(1.0D+00-S)-W*N
      ROTATION_MAT(2,2)=V*V*(1.0D+00-S)+S
      ROTATION_MAT(2,3)=V*W*(1.0D+00-S)+U*N
      
      ROTATION_MAT(3,1)=U*W*(1.0D+00-S)+V*N
      ROTATION_MAT(3,2)=V*W*(1.0D+00-S)-U*N
      ROTATION_MAT(3,3)=W*W*(1.0D+00-S)+S

     
   80 CONTINUE
      
      CLOSE(RW)
      CLOSE(RWW)
      END
      
C ********************************************************************************** C 

      SUBROUTINE CROSS_PROD(X,Y,Z)
      
      DOUBLE PRECISION X(3),Y(3),Z(3),TEMP
      INTEGER I
      
      Z(1) = X(2)*Y(3) - X(3)*Y(2)
      Z(2) = -1 * (X(1)*Y(3) - X(3)*Y(1))
      Z(3) = X(1)*Y(2) - X(2)*Y(1)
      
C      TEMP = SQRT(Z(1)**2 + Z(2)**2 + Z(3)**2)
      
C      Z(1)=Z(1)/TEMP
C      Z(2)=Z(2)/TEMP
C      Z(3)=Z(3)/TEMP
      
C      WRITE(*,*) 'THE VALUE OF K ARE', K(1), K(2), K(3)
      
      END

C ********************************************************************************** C 

C ********************************************************************************** C 

      SUBROUTINE GET_BIAS_TEXTURE(MAT,ROTATION_MAT,POLE,HEMI)
      
      IMPLICIT NONE
      
      DOUBLE PRECISION PI
      
      PARAMETER (PI=3.141592654)
      
      INTEGER I,J,TAG_HERE,RADIOUS,POLE,G,HEMI
      DOUBLE PRECISION TEMP(4),MAT(3,3),ROTATION_MAT(3,3)
      DOUBLE PRECISION AL(12,3),SAMPLE_X(3),GM_CONV(12,3)
      DOUBLE PRECISION SAMPLE_Y(3),SAMPLE_Z(3),NEW_MAT(3,3)
      DOUBLE PRECISION X_ST,Y_ST,DIA(3),H,K,L,NEW_MAT_INV(3,3)
      DOUBLE PRECISION COS_THETAS,THETAS,ALPHA_NEW,Z
      DOUBLE PRECISION COS_ALPHASS,ALPHASS,ALPHAS,P,Q,R
      DOUBLE PRECISION COS_ALPHAS,A,AA(9),BB(9),CC(9)
      
      RADIOUS=4
      SAMPLE_X(1)=1
      SAMPLE_X(2)=0
      SAMPLE_X(3)=0 
            
      SAMPLE_Y(1)=0
      SAMPLE_Y(2)=1
      SAMPLE_Y(3)=0
      
      SAMPLE_Z(1)=0
      SAMPLE_Z(2)=0
      SAMPLE_Z(3)=1

      DO 110 I=1,12
         DO 120 J=1,3
             GM_CONV(I,J)=0  
  120    CONTINUE
  110 CONTINUE
  
      DO 40 I=1,3
         DO 50 J=1,3
             NEW_MAT(I,J)=0  
   50    CONTINUE
   40 CONTINUE
   
      DO 44 I=1,12
         DO 55 J=1,3
             AL(I,J)=0  
   55    CONTINUE
   44 CONTINUE
  
      
      IF(POLE .EQ. 100) THEN
      
        AL(1,1)=1
        AL(1,2)=0
        AL(1,3)=0
      
        AL(2,1)=0
        AL(2,2)=1
        AL(2,3)=0
      
        AL(3,1)=0
        AL(3,2)=0
        AL(3,3)=1
      
        AL(4,1)=-1
        AL(4,2)=0
        AL(4,3)=0
      
        AL(5,1)=0
        AL(5,2)=-1
        AL(5,3)=0
      
        AL(6,1)=0
        AL(6,2)=0
        AL(6,3)=-1
        
        G=6
        
      ELSE IF(POLE .EQ. 111) THEN
        
        A=1
        
        AL(1,1)=1
        AL(1,2)=1
        AL(1,3)=1
      
        AL(2,1)=-1
        AL(2,2)=-1
        AL(2,3)=-1
      
        AL(3,1)=-1
        AL(3,2)=1
        AL(3,3)=1
      
        AL(4,1)=1
        AL(4,2)=-1
        AL(4,3)=1
      
        AL(5,1)=1
        AL(5,2)=1
        AL(5,3)=-1
      
        AL(6,1)=-1
        AL(6,2)=-1
        AL(6,3)=1
        
        AL(7,1)=1
        AL(7,2)=-1
        AL(7,3)=-1
      
        AL(8,1)=-1
        AL(8,2)=1
        AL(8,3)=-1
        
        G=8
        
      ELSE IF(POLE .EQ. 110) THEN
      
        A=1
        
        AL(12,1)=1
        AL(12,2)=1
        AL(12,3)=0
      
        AL(11,1)=-1
        AL(11,2)=-1
        AL(11,3)=0
      
        AL(10,1)=-1
        AL(10,2)=1
        AL(10,3)=0
      
        AL(9,1)=1
        AL(9,2)=-1
        AL(9,3)=0
      
        AL(8,1)=0
        AL(8,2)=1
        AL(8,3)=1
      
        AL(7,1)=0
        AL(7,2)=-1
        AL(7,3)=-1
       
        AL(6,1)=0
        AL(6,2)=-1
        AL(6,3)=1
        
        AL(5,1)=0
        AL(5,2)=1
        AL(5,3)=-1
        
        AL(4,1)=1
        AL(4,2)=0
        AL(4,3)=1
      
        AL(3,1)=-1
        AL(3,2)=0
        AL(3,3)=-1
     
        AL(2,1)=-1
        AL(2,2)=0
        AL(2,3)=1
    
        AL(1,1)=1
        AL(1,2)=0
        AL(1,3)=-1

        G=12
        
      END IF
      
C      WRITE(*,*) 'G = ',G
       
      
      CALL MAT_MUL(NEW_MAT,MAT,ROTATION_MAT)
      
      DO 10 I=1,3
         WRITE(98,*) NEW_MAT(I,1)
         WRITE(98,*) NEW_MAT(I,2)
         WRITE(98,*) NEW_MAT(I,3)
   10 CONTINUE
   
      CALL CALCULATE_INVERSE(NEW_MAT,NEW_MAT_INV)

C ** Multiplying converted gamma pole with D-Z to have the angle theta and the z value **   
      
      DO 80 I=1,G
         DO 20 K=1,3
            DO 30 L=1,3
C *************************** Plotting austenite poles *************************
                  GM_CONV(I,K)=GM_CONV(I,K) + NEW_MAT_INV(K,L)*AL(I,L)
C ******************************************************************************
   30       CONTINUE
   20    CONTINUE 
      COS_THETAS=(SAMPLE_Z(1)*GM_CONV(I,1)+SAMPLE_Z(2)*GM_CONV(I,2)
&     +SAMPLE_Z(3)*GM_CONV(I,3))
&     /(SQRT(GM_CONV(I,1)**2+GM_CONV(I,2)**2+GM_CONV(I,3)**2))

          
      THETAS=ACOS(COS_THETAS)
      
      IF(THETAS .GT. PI/2 .AND. THETAS .LE. PI) THEN
        THETAS=PI-THETAS
        TAG_HERE=0
      ELSE IF(THETAS .GE. 0 .AND. THETAS .LE. PI/2) THEN
        THETAS=THETAS
        TAG_HERE=1
      END IF
        
C      WRITE(*,*) 'THETA', THETAS*180/PI,COS_THETAS,
C&     GM_CONV(I,1),GM_CONV(I,2),GM_CONV(I,3)     

      Z=RADIOUS*TAN(THETAS/2)
      
C       WRITE(*,*) 'THETA-Z',Z

C ***************************************************************************************     

C ***** Multiplying converted alpha pole (hkl) with D-X to have the angle alpha *********

      DIA(1)=0
      DIA(1)=0
      DIA(3)=0
      
      A=(SQRT(GM_CONV(I,1)**2+GM_CONV(I,2)**2+GM_CONV(I,3)**2))
      
      P=GM_CONV(I,1)/A
      Q=GM_CONV(I,2)/A
      R=GM_CONV(I,3)/A
      
      IF(TAG_HERE .EQ. 1) THEN
        DIA(1)=4*(P+SAMPLE_Z(1))
        DIA(2)=4*(Q+SAMPLE_Z(2))
        DIA(3)=4*(R+SAMPLE_Z(3))
      ELSE
        DIA(1)=4*(P-SAMPLE_Z(1))
        DIA(2)=4*(Q-SAMPLE_Z(2))
        DIA(3)=4*(R-SAMPLE_Z(3))
      END IF
      
      A=SQRT(DIA(1)**2+DIA(2)**2+DIA(3)**2)
      
      DIA(1)=DIA(1)/A
      DIA(2)=DIA(2)/A
      DIA(3)=DIA(3)/A

      H=4*P-((4*SAMPLE_Z(1)*P+4*SAMPLE_Z(2)*Q+4*SAMPLE_Z(3)*R)
&      /(DIA(1)*SAMPLE_Z(1)+SAMPLE_Z(2)*DIA(2)+SAMPLE_Z(3)
&      *DIA(3)))*DIA(1)

      K=4*Q-((4*SAMPLE_Z(1)*P+4*SAMPLE_Z(2)*Q+4*SAMPLE_Z(3)*R)
&      /(DIA(1)*SAMPLE_Z(1)+SAMPLE_Z(2)*DIA(2)+SAMPLE_Z(3)
&      *DIA(3)))*DIA(2)

      L=4*R-((4*SAMPLE_Z(1)*P+4*SAMPLE_Z(2)*Q+4*SAMPLE_Z(3)*R)
&      /(DIA(1)*SAMPLE_Z(1)+SAMPLE_Z(2)*DIA(2)+SAMPLE_Z(3)
&      *DIA(3)))*DIA(3)

C      K=4*Q-((4*P+8*Q+12*R)/(DIA(1)+2*DIA(2)+3*DIA(3)))*DIA(2)
C      K=4*Q-((4*P+8*Q+12*R)/(DIA(1)+2*DIA(2)+3*DIA(3)))*DIA(2)
C      L=4*R-((4*P+8*Q+12*R)/(DIA(1)+2*DIA(2)+3*DIA(3)))*DIA(3)      
      
      A=SQRT(H**2+K**2+L**2)
      
      H=H/A
      K=K/A
      L=L/A
     
      COS_ALPHAS=((H*SAMPLE_X(1))+(K*SAMPLE_X(2))+(L*SAMPLE_X(3)))

      ALPHAS=ACOS(COS_ALPHAS)
      
      COS_ALPHASS=((H*SAMPLE_Y(1))+(K*SAMPLE_Y(2))+(L*SAMPLE_Y(3)))

      ALPHASS=ACOS(COS_ALPHASS)
      
C      WRITE(*,*) 'HKL',H,K,L
C      WRITE(*,*) 'DIA',DIA(1),DIA(2),DIA(3)
C      WRITE(*,*) 'SAMPLE-Z',SAMPLE_Z(1),SAMPLE_Z(2),SAMPLE_Z(3)
C      WRITE(*,*) 'ALPHA',COS_ALPHAS,COS_ALPHASS
      
      IF(ALPHAS .GE. PI/2) THEN
        ALPHA_NEW=PI-ALPHAS
      ELSE
        ALPHA_NEW=ALPHAS
      END IF
      

      IF(ALPHAS .GE. PI/2 .AND. ALPHASS .GE. PI/2) THEN
        ALPHA_NEW=PI+ALPHA_NEW
      ELSE IF(ALPHAS .GE. PI/2 .AND. ALPHASS .LE. PI/2) THEN
        ALPHA_NEW=PI-ALPHA_NEW
      ELSE IF(ALPHAS .LE. PI/2 .AND. ALPHASS .LE. PI/2) THEN
        ALPHA_NEW=ALPHA_NEW
      ELSE IF(ALPHAS .LE. PI/2 .AND. ALPHASS .GE. PI/2) THEN
        ALPHA_NEW=2*PI-ALPHA_NEW
      END IF
      
C      WRITE(*,*) 'ALPHA', ALPHA_NEW*180/PI
      
      
C ******************************************************************************    

C ******************** Get the X-Y co-ordinates ********************************


      IF(COS_THETAS.EQ. 1 .OR. COS_THETAS.EQ. -1) THEN
          X_ST=0
          Y_ST=0
      ELSE
          X_ST=Z*COS(ALPHA_NEW)
          Y_ST=Z*SIN(ALPHA_NEW)
      END IF
      
C ****************************************************************************** 
      IF (HEMI .EQ. 1) THEN
         IF(TAG_HERE .EQ. 0) THEN
           WRITE(99,*) X_ST,Y_ST
         END IF
      ELSE IF(HEMI .EQ. 0) THEN
         IF(TAG_HERE .EQ. 1) THEN
           WRITE(99,*) X_ST,Y_ST
         END IF
      ELSE IF(HEMI .EQ. 2) THEN
         WRITE(99,*) X_ST,Y_ST
      END IF
C      WRITE(99,*) X_ST, Y_ST
C      WRITE(*,*) X_ST, Y_ST
      
   80 CONTINUE
      
      END
      
C----------------------------------------------------------------
C To evaluate the product A  of two 3x3 matrices B and C
C
      SUBROUTINE MAT_MUL(A,B,C)
      DOUBLE PRECISION A(3,3),B(3,3),C(3,3)
      INTEGER I,J,K
      
      DO 10 I=1,3
         DO 20 J=1,3
            DO 30 K=1,3
               A(J,I)=A(J,I)+B(J,K)*C(K,I)
   30       CONTINUE
   20    CONTINUE
   10 CONTINUE
   
c      WRITE(*,*) 'NEW_MAT'
      
   
C
      RETURN
      END
C----------------------------------------------------------------   

C ******************** This subroutine calculates the inverse of a matrix ******

      SUBROUTINE CALCULATE_INVERSE(TATA,MAT_INV)   
      
      INTEGER I,J
      DOUBLE PRECISION DET,TATA(3,3)
      DOUBLE PRECISION MAT_INV(3,3)
      
      DET=TATA(1,1)*(TATA(2,2)*TATA(3,3)-TATA(2,3)*TATA(3,2))
&         -TATA(1,2)*(TATA(2,1)*TATA(3,3)-TATA(2,3)*TATA(3,1))
&         +TATA(1,3)*(TATA(2,1)*TATA(3,2)-TATA(2,2)*TATA(3,1))

      DO 10 I=1,3
         DO 20 J=1,3
            MAT_INV(I,J)=0
   20    CONTINUE
   10 CONTINUE

      MAT_INV(1,1)=(TATA(2,2)*TATA(3,3)-TATA(2,3)*TATA(3,2))/DET
      MAT_INV(1,2)=(TATA(3,2)*TATA(1,3)-TATA(3,3)*TATA(1,2))/DET
      MAT_INV(1,3)=(TATA(1,2)*TATA(2,3)-TATA(1,3)*TATA(2,2))/DET
      
      MAT_INV(2,1)=(TATA(2,3)*TATA(3,1)-TATA(2,1)*TATA(3,3))/DET
      MAT_INV(2,2)=(TATA(3,3)*TATA(1,1)-TATA(3,1)*TATA(1,3))/DET
      MAT_INV(2,3)=(TATA(1,3)*TATA(2,1)-TATA(1,1)*TATA(2,3))/DET
      
      MAT_INV(3,1)=(TATA(2,1)*TATA(3,2)-TATA(2,2)*TATA(3,1))/DET
      MAT_INV(3,2)=(TATA(3,1)*TATA(1,2)-TATA(3,2)*TATA(1,1))/DET
      MAT_INV(3,3)=(TATA(1,1)*TATA(2,2)-TATA(1,2)*TATA(2,1))/DET
      
      END
      
C ******************************End Subroutine *********************************    
